// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Основной цикл программы

#include "configuration.h"
#include "declarations.h"

char my_tx_buffer[MY_TX_BUFFER_SIZE];
char my_rx_buffer[MY_RX_BUFFER_SIZE];

void GetStateSerial()
{
  sprintf(my_tx_buffer,"%lu\tT=\t%3u\t%3u\t%3u\tGlv=%4u\tI=%3u\tS=%3u\t%4uW\tOFF=%1i\t%3imm\t%3uV", Seconds, temps[0], temps[1], temps[2], U_GLV, IspReg, StateMachine, UstPower, (int) flAllOff, U_MPX5010, MaxVoltsOut);
  Serial.println(my_tx_buffer);
}

void GetStateSerialErr()
{
  sprintf(my_tx_buffer,"Err ds18b20 CntDs=%3u NumDs=%3u", CntErrDs18, NumErrDs18);
  Serial.println(my_tx_buffer);
}

void loop()
{
  int i, j;
  char k;
  unsigned long SqNapr = 0, SqNaprPrev = 0, FindPower, FindPowerKLP;
  int FindKtKLP;
  byte data[12];
  byte present = 0;
  unsigned int raw;
  int raw1;
  byte ds18b20CRC;
  //  static char  FlFindPower;
  //  static char  FlFindPowerKLP;
  char flErrDs18;
  //unsigned int tic;
  static char trig_on = true; //Признак того, что выдаем в данном цикле - 0 или 1

  if (bLCDclearFlag) {
    lcd.clear();
    bLCDclearFlag = false;
  }

#ifdef DEBUG
  my_debug();
#endif

  //  static int PowerPrev=0;
  //  static int UstPowerPrev=0;
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  // print the number of seconds since reset:
  // Если есть необходимость произвести отображениеш  информации на дисплее и среднеквадратичное уже рассчитано.
  // И контроллер находится в режиме "лазанья" по меню, тогда отображаем информацию.
  // Или контроллер не находится в режиме ошибки.
  // Обработка уровней
  if (flNeedReadAlarm && StateVolts != 1)
  {
#ifndef DEBUG
    ReadAlarm();
#endif
    flNeedReadAlarm = 0;
  }

  // MQTT code by max506 & limon
#if defined(USE_MQTT_BROKER) && (USE_MQTT_BROKER==1)

  // Отправка оперативных данных
  SendOperData();

  // Получение команды от клиентов
  RecvSerial3();

#endif  // USE_MQTT_BROKER

  // Для обеспечения равномерности выборки делаем это в цикле подряд.
  while (StateVolts == 1)
  {
#ifdef DEBUG
    if (Serial.available()) return;
#endif

#if USE_ASC712==0 // если датчик тока не используем, тогда читаем значение и делим его на два
    if (!flCorrASC712)  resultU = (analogRead(PIN_READU) >> 1); // читаем показания с pin А3 и делим их на два, для увеличения измеряемого выходного напряжения.
    else
    {
      if (StateVolts == 1)
      {
        if (CorrectASC712 == 3)
        {
          resultU = analogRead(PIN_READI) - 512; // читаем показания с датчика тока.
          if (resultU < 0) resultU = -resultU;
        }
        else
        {
          resultU = analogRead(PIN_READI) - 512; // читаем показания с датчика тока.
          if (resultU < 0) resultU = -resultU;
        }
      }
    }

#else
    // Если используем датчик тока, тогда читаем значение, если оно больше 512, значит приводим его к 512;
    resultU = analogRead(PIN_READI) - 512; // читаем показания с датчика тока.
    if (resultU < 0) resultU = -resultU;
#endif

    // Пробуем расчет квадратов на лету.
    SqNaprT = SqNaprT + (unsigned long) resultU * (unsigned long) resultU;
#ifdef TESTRM
    //        tic=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера
    //        tic_adc[index_input]=tic;
#endif
    if (index_input < MAX_INDEX_INPUT) index_input++;
    else StateVolts = 0; // Если превышер размер массива, ставим флаг расчета заново.

  }

  if (NeedDisplaying && (StateVolts != 1 || IspReg >= 240) && FlState == 0)
  {
    DisplayData();
  }

  // Сканируем клавиатуру, если установлен флаг.
  if (flNeedScanKbd == 1 )
  {
    ScanKbd();
    flNeedScanKbd = 0;
  }

  if (flNeedTemp == 1 && IspReg >= 240)
  {
    flNeedAnalyse = 1;
  }

  if (StateVolts != 1)
  {
    if (flNeedTemp == 1)
    {
      flNoPhase = 1; // временно убираем с фазового управления клапана, чтобы они не закрылись
      OpenKLP(); // открываем на всякий случай все клапана, которые необходимо открыть.
      if (StepOut == 0)
      {
        ds.reset();
        ds.write(0xCC, 1);        // start conversion, with parasite power on at the end
        ds.write(0x44, 1);        // start conversion, with parasite power on at the end
        flNeedTemp = 0;
        for (j = 0; j < ds1820_devices; j++) ds1820_flread[j] = 0;
        StepOut = 1;
      }
      else
      {

        flErrDs18 = 0; // Сбрасываем флаг nошибки датчика ds18b20
        for (j = 0; j < ds1820_devices; j++)
        {
          // По каждому датчику температуру считаем три раза
          k = 0;
          while (k < 3)
          {
            if (ds1820_flread[j] == 0)
            {
              present = ds.reset();

#ifdef TIMING
              TCNT4H = 0x00;
              TCNT4L = 0x00;
#endif

              // Здесь вообще засада, передача кода датчика занимает около 1600 тиков таймера, что гарантирует пропуск регуляции как минимум одного полупериода.
              // Возможно решение - посадить каждый датчик на отдельный ПИН, тогда код датчика передавать не нужно.
              ds.select(ds1820_rom_codes[j]);

#ifdef TIMING
              unsigned int Tic2 = (int) TCNT4L | (int) (TCNT4H << 8); // Расчитывааем текущее значение таймера
              sprintf_P(my_tx_buffer, PSTR("TicDs18Select=%i"), Tic2);
              FlUsart = 1;
#endif

              ds.write(0xBE);         // Read Scratchpad
              //          Serial.print(present,HEX);
              //          Serial.print(" ");
              //        Читаем пока только 2 байта из 9, остальные не трогаем.
              for ( i = 0; i < 9; i++)
              {
                data[i] = ds.read();
                //            Serial.print(data[i], HEX);
                //            Serial.print(" ");
              }
              //          Serial.print(" CRC=");
              ds18b20CRC = OneWire::crc8(data, 8);

              if (ds18b20CRC != data[8]) //  Ошибка чтения, записываем признак ошибки
              {
#ifndef DEBUG
                if (!flErrDs18 && k == 2) // Если ранее в этом сеансе не было ошибок чтения датчика, то прибавляем количество ошибок чтения на единицу
                {
                  flErrDs18 = 1;
                  CntErrDs18++;
                  NumErrDs18 = j + 1; // Запоминаем номер сглючившего датчика.
                  if (CntErrDs18 > 30) DispDopInfo = 4; // Устанавливаем признак вывода информации об ошибке если ошибок больше 4
                  if (FlToUSART) GetStateSerialErr();
                }
#endif
              }
              else // Если контрольная сумма совпадает, то считаем, что все нормально.
              {
                raw = (data[1] << 8) | data[0];
                if (raw & 0x8000)                         // Если там единица - число отрицательное и его надо преобразовать
                { // Стандартное преобразование отрицательного числа, которое в микроконтроллере в дополнительной кодировке
                  raw = (raw ^ 0xffff) + 1;            // Путем исключающего ИЛИ плюс единица
                  raw1 = raw * 5 / 8;
                  raw1 = -raw;
                }
                else
                  raw1 = raw * 5 / 8;
                // Температуру равной 850 считаем ошибочной.
                if (raw1 == 850 || raw1 > 1200)
                {
                  // Если температура скаканула больше чем на 10 градусов, то считаем ошибкой.
                  if (abs(raw1 - temps[j]) > 100 && temps[j] != 0 || raw1 > 1200)
                  {
                    if (!flErrDs18 && k == 2) // Если ранее в этом сеансе не было ошибок чтения датчика, то прибавляем количество ошибок чтения на единицу
                    {
                      flErrDs18 = 1;
                      CntErrDs18++;
                      NumErrDs18 = j + 1; // Запоминаем номер сглючившего датчика.
                      if (CntErrDs18 > 30) DispDopInfo = 4; // Устанавливаем признак вывода информации об ошибке если ошибок больше 4
                      if (FlToUSART) GetStateSerialErr();
                    }
                  }
                }
                else

                {
#ifndef DEBUG
                  // Если температуру считали успешно, то поставим соотв флаг.
                  ds1820_flread[j] = 1;
                  k = 3; // Выходим из цикла чтения
                  temps[j] = raw1;
                  // Если мы сейчас не находимся в режиме ввода поправок к датчикам, то прибавляем к температуре значение поправки

                  if (FlState != 300)
                  {
                    temps[j] = temps[j] + (int) ds1820_popr[j];
                  }
                  // Запоминаем максимальную температуру датчиков
                  if (Maxtemps[j] < temps[j]) Maxtemps[j] = temps[j];
#endif
                }
              }
            }
            k++;
          }

        }

        StepOut = 0;
        flNeedTemp = 0;

#ifdef DEBUG
        flErrDs18 = 0;
#endif

        flNoPhase = 0; // восстанавливаем фазовое управление клапанами.

        if (!flErrDs18) // Если не было ошибок, то сбрасываем счетчики.
        {
          flNeedAnalyse = 1; // Все необходимые данные прочитаны устанавливаем флаг того, что нужно анализировать состояние выполнения процесса.
          CntErrDs18 = 0;
          NumErrDs18 = 0;
          // Сбрасываем признак вывода информации об ошибке
          if (DispDopInfo == 4) DispDopInfo = 0;
        }
        else
        {
          // Если были ошибки, заново запускаем определение температуры
          ds.reset();
          ds.write(0xCC, 1);        // start conversion, with parasite power on at the end
          ds.write(0x44, 1);        // start conversion, with parasite power on at the end
          flNeedTemp = 0;
          StepOut = 1;
        }
      }
    }
  }

  if (CntErrDs18 > MAX_ERR_DS18)
  {
    flNeedAnalyse = 1;
#ifndef TEST
    IspReg = 251;    // Переводим контроллер в режим ошибки датчиков.
#endif
  }

  if (flNeedAnalyse == 1)
  {

    trig_on = !trig_on;
    digitalWrite(PIN_RST_WDT, trig_on); // Выдаем признак работы для внешнего контроля

#ifdef TEST
    Serial.println(F("BEGIN PROSSES"));
#endif

    switch (IspReg)
    {
      case 102: //Текущее состояние - термостат
        //UstPower=0;
        ProcessTermostat();
        break;
      case 103: //Текущее состояние - регулятор мощности
        if (StateMachine < 100) UstPower = UstPowerReg;
        else UstPower = 0;
        // Если стоит признак авто-детектирования ТЭНа, то мощность устанавливаем максимально возможную.
        if (flAutoDetectPowerTEN == 1 && StateMachine < 100) UstPower = 9999;
        break;
      case 108:
        ProcessTimerMaxPower();
        break;
      case 117:
        ProcessDistillFractional();
        break;
      case 118: //Текущее состояние - фракционная ректификация
      case 109: //Текущее состояние - ректификация
        ProcessRectif();
        break;
      case 104: //Текущее состояние - первый недробный перегон
      case 106: //Текущее состояние - второй дробный
      case 107: //Текущее состояние - третий дробный
        ProcessSimpleDistill();
        break;

      case 105: //Текущее состояние - отбор голов
        ProcessSimpleGlv();
        break;
      case 110:
        ProcessDistilDefl();
        break;
      case 129:
        ProcessTestKLP();
        break;
      case 130:
      case 248:
      case 249:
      case 250:
      case 251:
      case 252:
      case 253:
      case 254:
#if NUM_PHASE>1
        KlOpen[KLP_HLD] = 100;
        KlClose[KLP_HLD] = 0;
        digitalWrite(PIN_KLP_BEG + KLP_HLD, HIGH);
#endif
          // Тревога либо протечка воды, отключаем воду, отключаем мощность.
          UstPower = 0;
        CloseAllKLP();
        // Пищим, независимо от настроек.
#ifndef TEST
        my_beep(BEEP_LONG * 5);
#endif

        digitalWrite(PIN_RZG_ON, !RELAY_HIGH);
        digitalWrite(PIN_TRIAC, LOW);
        digitalWrite(PIN_ALL_OFF, ALL_OFF_HIGH);
        flAllOff = 1;
        break;

    }

    if (FlToUSART) GetStateSerial();

#ifdef TEST
    Serial.println(F("END PROSSES"));
#endif

    flNeedAnalyse = 0;
    RaspredPowerByPhase();
  }

  if (StateVolts != 1)
  {
#if NUM_PHASE<2

#endif  

  }
  //  анализ отладки

  if (FlUsart == 1)
  {
    // Признак того, что надо выдать информацию в ком-порт (есл ее вдруг невозможно сразу выдать, например, из прерывания).
    Serial.println(my_tx_buffer);
    FlUsart = 0;
  }
  // Начало расчета среднеквадратичного

  if (StateVolts == 2)
  {

#ifdef TESTRM
    Serial.println(F("BEGIN SQNAPR"));
    TCNT4H = 0x00;
    TCNT4L = 0x00;
#endif

    StateVolts = 3;

    // поскольку тут идет преобразование и умножение 32 разрядных чисел, делаем это по необходимости, а не каждый раз (хотя какая разница, тут и таких умножений дохрена)
    SqNapr = (long) 220 * 220 * 20 / PowerPhase[0]; // Рассчитали сопротивление ТЭНа, умноженное на 20
    R_TEN20 =  SqNapr;

#ifdef TESTRM
    Serial.print(F("UstPower="));
    Serial.println(UstPower);
    Serial.print(F("Power="));
    Serial.println(Power);
    Serial.print(F("NaprPeregrev="));
    Serial.println(NaprPeregrev);
    Serial.print(F("MaxVoltsOut="));
    Serial.println(MaxVoltsOut);
    Serial.print(F("R_TEN20="));
    Serial.println(R_TEN20);
#endif

    SqNapr = 0;
    SqNaprPrev = 0;
    //   MaxVolts=0;

#ifdef TESTRM
    TCNT4H = 0x00;
    TCNT4L = 0x00;
#endif

#ifdef TESTRM
    Serial.print(F("SqNapr="));
    Serial.println(SqNaprT);
    //Считаем напряжение в сети исходя из среднеквадратичного, средневыпрямленного, максимального
    Serial.print(F("RMS/AVG/MAX"));
    Serial.write(9);
    Serial.print((long) my_sqrt(SqNaprT / index_input));
    Serial.write(9);
    //    Serial.println((long)MaxVolts*707/1000);
#endif

#if USE_ASC712==0
    if (!flCorrASC712) // Расчет напряжения
    {

      TekPower = SqNaprT / index_input; // Определили квадрат напряжения

      // Но фактически мощность подаваемая на ТЭНы меньше из-за падения на симисторе.

      MaxVoltsOut = my_sqrt(TekPower); // Рассчитываем среднеквадратичное

#ifdef TESTRM
      Serial.print(F("index_input="));
      Serial.println(index_input);
      Serial.print(F("TekPower2="));
      Serial.println(TekPower);
#endif

      TekPower = (TekPower * 20) / R_TEN20; // Определили фактическую мощность в зависимости от сопротивления ТЭНа

#ifdef TESTRM
      Serial.print(F("TekPower2="));
      Serial.println(TekPower);
#endif

      TekPowerKLP = (unsigned long) NaprPeregrev * NaprPeregrev;

#ifdef TESTRM
      Serial.print(F("UstPower="));
      Serial.println(UstPwrPH1);
      Serial.print(F("FactPower="));
      Serial.println(FactPower);
      Serial.print(F("MaxVoltsOut="));
      Serial.println(MaxVoltsOut);
      Serial.print(F("TekPowerKLP="));
      Serial.println(TekPowerKLP);
#endif

      if (FactPower > 15 && CorrectASC712 >= 2 && !(UstPwrPH1 >= PowerPhase[0])) // Если фактическая мощность рассчитана и мы не находимся в режиме подачи полного напряжения на ТЭНы
      {
        // Это формулы, для ПИД-регулировани, предоставленные коллегой m16 c homedistiller.ru
        //          ;******************************************************************************
        //          ;*
        //          ;*	new_err = Ps_r - Pv			;вычисляем новую ошибку
        //          ;*
        //          ;*
        //          ;*	It = It + ki_r * new_err	        ;считаем интегральную составляющую
        //          ;*
        //          ;*		if ( It < 0.0 ) It = 0.0        ;если интегральная отрицательна то присваиваем ей ноль
        //          ;*		else  if( It > Sc_r ) It = Sc_r	;если интегральная превысит установленный предел то присваиваем значение предела
        //          ;*
        //          ;*	Dt =  kd_r * ( new_err - old_err )	;считаем дифференциальную
        //          ;*
        //          ;*	Ut = ( new_err*10 + It + Dt ) /  Sc_r	;вычисляем % от максимальной мощности
        //          ;*
        //          ;*		if ( Ut < 0.0 ) Ut = 0.0
        //          ;*		else if ( Ut > 100 ) Ut = 100
        //          ;*
        //          ;*	old_err = new_err                       ;присваиваем значению новой ошибке предыдущую
        //          ;******************************************************************************
        //          где
        //          Ps_r - мощность установленная
        //          Pv   - мощность измеренная
        //          new_err- новая ошибка рассогласования
        //          old_err- предыдущая ошибка рассогласования
        //          Sc_r   - максимальное накопление интегральной составляющей
        //          It     - интегральная
        //          ki_r   - коэф. интегральной
        //          Dt     - диф. составляющая
        //          kd_r   - коэф. дифференциальной
        //          Ut     - % от макс. мощности
        // Считаем ошибку рассоглавования.

        // Ошибку рассогласования учитываем, если она не более 1/8 мощности ТЭНа.
        NewErr = ((long)UstPwrPH1 - (long)FactPower) * 200 / (long)Power;
        if (NewErr < -30) NewErr = -30;
        else if (NewErr > 30) NewErr = 30;

        Dt = NewErr - OldErr;
        It = It + NewErr;
        // Накопленную ошибку не более 1/2 мощности ТЭНа.
        if (It < -100) It = -100;
        else if (It > 100) It = 100;

        OldErrOut = OldErr; // Старая ошибка для отображения на экране
        OldErr = NewErr; // Запоминаем старую ошибку.
        //          if (UstPower>FactPower) It=It+5;
        //          else
        //            if (UstPower<FactPower) It=It-5;
      }
      else
      {
        // Если мощность не рассчитана, то считаем, что находимся в режиме отладки и не подключили ТЭНы В этом случае просто делаем фазовое регулирование исходя из
        // входного напряжения, не учитывая фактическую мощность, рассчитанную исходя из датчика тока на ТЭНах
        NewErr = 0;
        OldErr = 0;
        OldErrOut = 0;
        It = 0;
        Dt = 0;
      }

      // Пока без коэффиццииенов
      FindKt = (long)(UstPwrPH1) * 200 / TekPower;   // Установили коэффициент поиска мощности для регулятора мощности как соотношение необходимой мощности к имеющейся в данный момент.
      FindKt = FindKt + It;                          // Прибавляем коэффициент.


      if (FindKt > 200 || It == -100)
      {
        CntErrPower++;
        if (UstPwrPH1 < PowerPhase[0] && UstPwrPH1 > 15 && CntErrPower > 100 && !flNoAlarmLowPower)
        {
          if (FindKt > 200)  {
            DispDopInfo = 3;
            FindKt = 200;
          } // Выводим на экран информацию о низком напряжении но только в том случае, когда не в режиме разгона и установленная мощность больше 15
          else DispDopInfo = 6;            // и в том случае когда не установлено, что не нужно выводить предупреждение о низком уровне напряжения
#if NUM_PHASE>1
          if (FindKt >= 200)
          {
            KlOpen[KLP_HLD] = 100; // Раз в секунду
            KlClose[KLP_HLD] = 100;
          }
          else
          {
            KlOpen[KLP_HLD] = 15; // Два раза в секунду
            KlClose[KLP_HLD] = 15;
          }

#endif
        }
      }
      else
      {
        CntErrPower = 0;
#if NUM_PHASE>1
        KlOpen[KLP_HLD] = 0;
        KlClose[KLP_HLD] = 50;
#endif

        if (DispDopInfo == 3 || DispDopInfo == 6)
        {
          DispDopInfo = 0; // Убираем информацию о низком напряжении, если она была ранее установлена
        }

      }

#if NUM_PHASE>1
      if (IspReg >= 240)
      {
        KlOpen[KLP_HLD] = 100;
        KlClose[KLP_HLD] = 0;
      }
#endif

      // В клапанах тоже учитываем поправку мощности
      //TekPowerKLP=(TekPowerKLP+It)*1000/( (long) MaxVoltsOut* (long)MaxVoltsOut);
      //Пока убираем поправку мощности в клапанах, возможно из-за этого "пробивает" симистор.
      TekPowerKLP = (TekPowerKLP) * 1000 / ( (long) MaxVoltsOut * (long)MaxVoltsOut);

      FindKtKLP = TekPowerKLP; // Установили коэффициент поиска мощности для клапанов

      // Проверка минимума и максимума
      if (FindKtKLP > 1000) FindKtKLP = 1000;
      if (FindKtKLP < 5) FindKtKLP = 5;

#ifdef TESTRM
      Serial.print(F("NewErr="));
      Serial.println(NewErr);
      Serial.print(F("OldErr="));
      Serial.println(OldErrOut);
      Serial.print(F("FindKt="));
      Serial.println(FindKt);
      Serial.print(F("FindKtNoErr="));
      Serial.println((long)(UstPower) * 1000 / TekPower);
      Serial.print(F("NaprPeregrev="));
      Serial.println(NaprPeregrev);
      Serial.print(F("FindKtKLP="));
      Serial.println(FindKtKLP);
      Serial.print(F("SqNaprT="));
      Serial.println(SqNapr);
      Serial.print(F("SqNaprPrev="));
      Serial.println(SqNaprPrev);
#endif

      if (FindKt < 1) FindKt = 1;
      if (FindKt > 200) FindKt = 200;

      // Поскольку таблица разбита по мощности равномерно в пределах 5/1000 доли, то нет необходимости высчитывать и искать по таблице, достаточно просто поделить.
      TimeOpenTriac = tableS10[FindKt - 1];
      TimeOpenTriac *= 10;
      // Учиываем предельно допустимый угол открытия триака
      if (FindKtKLP < 1000)
      {
        TimeOpenKLP  = tableS10[FindKtKLP / 5 - 1];
        // Защита от "дребезга клапана" на малых углах открытия симистора.
        if (TimeOpenKLP < 70) TimeOpenKLP = 0;
        TimeOpenKLP *= 10;

      }
      else
        TimeOpenKLP = 0;


      if (TimeOpenKLP <= 10) TimeOpenKLP = 9999; // Если не нашли нужную мощность, то устанавливаем максимальную.
      if (flAutoDetectPowerTEN) TimeOpenTriac = 9999;
    }
    else // Это расчет фактического тока и фактической мощности
    {

      if (CorrectASC712 == 3) // Расчет по напряжениию
      {
        TekPower = SqNaprT / index_input; // Определили квадрат напряжения
        MaxIOut = my_sqrt(TekPower); // Рассчитываем среднеквадратичное
#ifdef TESTRM
        Serial.print(F("index_input="));
        Serial.println(index_input);
        Serial.print(F("TekPower2="));
        Serial.println(TekPower);
#endif
        FactPower = (TekPower * 20) / R_TEN20; // Определили фактическую мощность в зависимости от сопротивления ТЭНа

      }
      else
      {
        // Здесь определили квадрат тока умноженный на 10.
        SqNaprPrev = SqNaprT * 100 / ((unsigned long) index_input * SENSITIVE_ASC712);
        // Определили ток, умноженный на 10 (для вывода на экран).
        MaxIOut = my_sqrt((long)SqNaprPrev * 100 / SENSITIVE_ASC712);
        if (flAutoDetectPowerTEN)
        {
          FindPower = (long) SqNaprPrev * 100 / (SENSITIVE_ASC712);
          //            Serial.print("I^2=");
          //            Serial.println(my_sqrt(FindPower));
          TekPower = (unsigned long) 220 * 22 * my_sqrt(FindPower) / MaxVoltsOut;
          if (TekPower != 0)
          {
            Power = (int)(TekPower / 10) * 10;
            PowerPhase[0] = Power;
          }
        }

        FindPower = (long) SqNaprPrev * R_TEN20 / (20 * SENSITIVE_ASC712);
        FactPower = FindPower;

#ifdef TESTRM
        Serial.print(F("SqNaprT="));
        Serial.println(SqNaprT);
        Serial.print(F("index_input="));
        Serial.println(index_input);
        Serial.print(F("index_input*SENSITIVE_ASC712="));
        Serial.println((unsigned long)index_input * SENSITIVE_ASC712);
        Serial.print(F("SqNaprPrev="));
        Serial.println(SqNaprPrev);
        Serial.print(F("FindPower="));
        Serial.println(FindPower);
        Serial.print(F("FactPower="));
        Serial.println(FactPower);
#endif
      }
    }

#endif

    //   Сумму квадратов измерений определили, она хранится в переменной SqNapr.
    //   Теперь надо перевести это в фактический ток.
#if USE_ASC712==1

    // Рассчитали сумму, пересчитанную в фактические значения тока.
    SqNaprPrev = SqNaprT * 100 / ( (unsigned long) index_input * SENSITIVE_ASC712);
#ifdef TESTRM
    Serial.print(F("SqNapr="));
    Serial.println(SqNapr);
    Serial.print(F("SqNaprPrev="));
    Serial.println(SqNaprPrev);
#endif

    FindPower = (long) SqNaprPrev * R_TEN20 / (20 * SENSITIVE_ASC712);
    FactPower = FindPower;

    MaxVoltsOut = my_sqrt(FindPower * R_TEN20 / 20);

    // Теперь зная мощность рассчитываем процент для брезенхема
    b_value[0] = (long) UstPower * b_size[0] / (long) FindPower;

    if (b_value[0] > b_size[0] && UstPower < Power) DispDopInfo = 3; // Выводим на экран информацию о низком напряжении если находимся не в режиме разгона.
    else if (DispDopInfo == 3) DispDopInfo = 0; // Убираем информацию о низком напряжении, если она была ранее установлена


#ifdef TESTRM
    Serial.print(F("MaxVoltsOut="));
    Serial.println(MaxVoltsOut);
    Serial.print(F("FindPower="));
    Serial.println(FindPower);
    Serial.print(F("FactPower="));
    Serial.println(FactPower);
    Serial.print(F("b_value[0]="));
    Serial.println((int)b_value[0]);
#endif
#endif

#ifdef TESTRM
    Serial.println(F("VOLTS"));
    Serial.print(F("j="));
    Serial.println(j);
    Serial.print(F("SqNapr="));
    Serial.println(SqNapr);
    Serial.print(F("SqNaprPrev="));
    Serial.println(SqNaprPrev);
    Serial.print(F("FindPower="));
    Serial.println(FindPower);
    Serial.print(F("b_value="));
    Serial.println(b_value[0]);
    Serial.print(F("OpenTriac="));
    Serial.println(TimeOpenTriac);
    Serial.print(F("OpenKLP="));
    Serial.println(TimeOpenKLP);
    Serial.print(F("COUNT="));
    Serial.println(index_input);
    Serial.print(F("TICZERO="));
    Serial.write(9);
    Serial.println(TicZero);
    Serial.println(F("ENDVOLTS"));
#endif

    StateVolts = 4;
  }

}
