// Последнее обновление 2017-08-15 by Phisik
// Файл содержит дефолтные настройки системы
// Часть настроек меняется в файле configuration.h при выборе версий, внимательно с этим!

#define PR_REWRITE_EEPROM  0
// Константа, которая содержит признак необходимости перезаписи энергонезависимой памяти (1-254).
// При запуске программы, значение 0-го байта ЕЕПРОМ сравнивается с этим значением,
// и если они не совпадают, тогда энергонезависимая памиять переписывается текущими значениями переменных
// То есть для значений переменных из скетча в контроллер, ее значение надо поменять например с 9 до 10.

//#define TEST        // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TESTMEM     // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TESTRM      // Раскомметировать, если нужно получать тестовые значения регулятора мощности через Serial1
//#define TESTERR     // Раскомметировать, если нужно получать тестовые значения ошибок через Serial1

//#define DEBUG // Режим отладки, в этом режиме не считываются значения датчиков температуры, а они передаются через монитор порта в ардуине
// в формате: сколько прибавить секунд, Температура датчика 0, Температура датчика 1,Температура датчика 2
// например: 60,820,810,800
//  (монитор порта надо настроить так, чтобы он выдавал возврат каретки и перевод строки)

#define USE_WDT 0 // Поставить 1, если использовать встроенный wath dog

#if USE_WDT
#include <avr/wdt.h>
#endif

#define BEEP_LONG 10              //Длительность сигнала оповещения о состояниях процесса

#define DEBOUNCE_CYCLES 15      // Число отсчетов таймера для устранения дребезга кнопок, было 20, и, как по мне, то кнопки тормозили

#define NUM_PHASE 0

#define KLP_HIGH 1              // Для клапанов с низким уровнем управления поменять 0 на 1

#define PEREGREV_ON 0           // Признак того, что надо использовать режим работы клапана в режиме защиты от перегрева. 1- использовать, 0-нет.

#define USE_12V_PWM 0           // Phisik: Признак того, что надо использовать защиту от перегрева 12В клапанов в версии с датчиком тока.
                                
#define NO_LOW_POWER_WARNING   0

#define USE_MQTT_BROKER          1  // MQTT protocol by max506 & limon

#define USE_MPX5010_SENSOR       0  // Phisik: раньше использовалось условие #ifdef PIN_MPX5010, из-за чего приходилось постоянно следить чтобы пин был не определен

#if PEREGREV_ON==0
#define PER_KLP_OPEN  0    // клапана открываем через полу-период (аналог диода), чтобы не перегревались и
#define PER_KLP_CLOSE 0    // чтобы не быо гидроударов
#else
#define PER_KLP_OPEN  1000 // клапана на воду переводим в фазовое управление, чтобы раз в 10 секунд на них подавалось полное напряжение, а затем напряжение
#define PER_KLP_CLOSE 0    // из контанты NAPR_PEREGREV 150 
#endif

#define USE_ASC712    0    // Значение здесь не менять!
// При использовании датчика тока установить значение "2" в экранном меню "Power correct ASC712".
#define SENSITIVE_ASC712 205   // Чувствительность датчика тока (показаний АЦП ардуино на 10 ампер тока 135 для 30А датчика, 205 для 20А датчика 82)

#define CNT_PERIOD       4     // Количество полу-периодов для обсчета среднеквадратичного.  Phisik:  не мало? может 20ть поставить?

#define USE_DIFAVTOMAT   0    // Константа, которая показывает, используется ли дифавтомат в работе системы нужно для того, чтобы при нормальном завершении процесса
// при плановом отключении дифавтомата не выдавалась тревога.

#define RELAY_HIGH       1           // Какой сигнал подавать на релейные выходы мешалки и разгона 
#define ALL_OFF_HIGH     1         // Какой сигнал подавать на выход ALL_OFF

#define MAX_COUNT_PROVODIMOST_SR 6  // Количество срабатываний датчика, по достижении которых можно точно сказать, что головы закончились

// Аварийная сигнализация
#define USE_ALARM_UROVEN 0  // Нужно ли использовать датчик уровня в приемной емкости ардуино 1- использовать для остановки всег процесса
                            // 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
#define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино

#define UROVEN_ALARM 50          // Уровень сигнала, достижение котогого свидетельсвует о срабатывании аналогового датчика (в обычном состоянии он выведен на значение около 1000 для датчиков на уменьшение напряжения)
                                 // или на значение около 0-10 для датчиков на увеличение напряжения
#define COUNT_ALARM 6            // Сколько должно держаться значение уровня, чтобы сработало предупреждение каждое значение - это полсекунды.
#define COUNT_ALARM_VODA 60      // Сколько должно держаться значение разлития воды, чтобы сработала тревога каждое значение - это полсекунды.
#define COUNT_ALARM_UROVEN 200   // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости каждое значение - это полсекунды.
#define COUNT_ALARM_UROVEN_FR 60 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости при фракционной перегонке каждое значение - это полсекунды.

#ifdef DEBUG
#define COUNT_ALARM_UROVEN 20 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости каждое значение - это полсекунды.
#endif

// Газовый сенсор
#define USE_GAS_SENSOR           0     // Надо ли использовать датчик загазованности
#define UROVEN_GAS_SENSOR        700   // Уровень сигнала, достижение котогого свидетельсвует о срабатывании датчика спиртового пара
#define COUNT_GAS_SENSOR         6     // Сколько должно держаться значение уровня, чтобы сработала тревога каждое значение - это полсекунды.
#define TIME_PROGREV_GAS_SENSOR  60    // Время для програва датчика спиртовых паров газа.

#define MAX_KLP 4           // Количество клапанов, которыми надо управлять по ШИМ. 

#define KLP_VODA     0      // Номер клапана для управления общей подачей воды в систему
#define KLP_DEFL     1      // Номер клапана для подачи воды в дефлегматор
#define KLP_DEFL_D   1      // Номер клапана для подачи воды в дефлегматор (при дистилляции с дефлегматором с паровым отбором)
#define KLP_GLV_HVS  2      // Номер клапана отбора головных и хвостовых фракций
#define KLP_SR       3      // Номер клапана отбора ректификата
#define KLP_HLD      2      // Номер клапана холодильника (для дистилляции) 

// Настройка датчиков температуры
#define MAX_DS1820   3

#define TEMP_KUB       0    // Номер датчика  термометра в кубе
#define TEMP_RK20      1    // Номер датчика термометра в РК 20 см от насадки
#define TEMP_TSA       2    // Номер термометра в трубке связи с атмосферой
#define MAX_TEMP_TSA   650  // Максимальная температура в датчике ТСА
#define TEMP_DEFL      1    // Номер датчика  термометра в дефлегматоре
#define TEMP_TERMOSTAT 0    // Номер датчика  термометра термостата

#define MAX_ERR_DS18 120    // После тридцати глюков подряд (а это тридцать секунд) от датчиков температуры, считаем, что процесс надо остановить.
#define MAX_ERR_MPX5010 120 // После 120 значений датчика давления подряд (а это 60 секунд) от датчиков температуры, считаем, что процесс надо остановить.

#define MAX_INDEX_INPUT 540

#define MAX_INDEX_BY_PERIOD 90
#define MIN_INDEX_BY_PERIOD 75

//#define UDP_PROTOKOL  // Признак использования UDP протокола для обмена

// Added by Phisik on 2017-08-15
// Здесь можно отключить ненужные нам пункты в меню
// NB! Пункты 129, 130 всегда должны быть в конце! Пункт 100 - вначале!
// Это связано с обработчиком нажатий в файле keyboard.cpp, строки 600-630

#define MENU_ITEMS 21
const bool menuEnableFlag[MENU_ITEMS] = {
  1,    // case 100:  Установка параметров  // Не отключается!
  1,    // case 101:  Displaying   // Отключается, но отключать не стоит
  1,    // case 102:  Термостат
  1,    // case 103:  Регулятор мощности
  1,    // case 104:  Первый (недробный) отбор
  0,    // case 105:  Отбор голов
  0,    // case 106:  Второй дробный отбор
  0,    // case 107:  Третий дробный отбор
  1,    // case 108:  Таймер + регулятор мощности
  0,    // case 109:  Ректификация
  1,    // case 110:  Дистилляция с дефлегматором
  0,    // case 111:
  0,    // case 112:
  0,    // case 113:
  0,    // case 114:
  0,    // case 115:
  0,    // case 116:
  0,    // case 117:  Фракционная перегонка
  0,    // case 118:  Ректификация Фракционная
  1,    // case 129:  Тест клапанов        // Не отключается!
  0     // case 130:  Внешнее управление   // Отключено.
};

// Здесь можно отключить ненужные нам пункты в меню настроек
#define SETTINGS_ITEMS 69
// Выше при работе с меню, мы перебирали режимы от "Установка параметров" до "Тест клапанов",
// считая, что эти пункты нам всегда нужны. При работе с меню, задаем первый и последний пункт
// вручную (case № - 200 ), т.к. тут у всех фломастеры разные

// Edited by Phisik on 2017-08-16
// Обновил алгоритм зацикливания. Теперь не надо задавать LAST_ITEM/FIRST_ITEM
// Просто расставить  1/0

const bool settingsEnableFlag[SETTINGS_ITEMS] = {
  1,    //  200: "Max_t_Tst=%5i"
  1,    //  201: "Power TEN=%5u"
  1,    //  202: "Power Reg=%5u"
  0,    //  203: "ParamUSART=%u"
  0,    //  204: "no "
  1,    //  205: "dtTermostat=%3i"
  1,    //  206: "Temp 1 Nedrobn Distill=%3i"
  0,    //  207: "Temp 2 Drobn Distill=%3i"
  0,    //  208: "Temp 3 Drobn Distill=%3i"
  0,    //  209: "Temp Razgon Rect (+Kub,-Kol)=%3i"
  0,    //  210: "Power Rectif=%3i"
  1,    //  211: "Vvod Popravok ds18b20 "
  0,    //  212: "Temp Okon Otbor Glv Rectif=%3i"
  0,    //  213: "CHIM Otbor GLV Rectif=%5u"
  0,    //  214: "%% CHIM Otbor GLV Rectif=%3i"
  0,    //  215: "CHIM Otbor SR Rectif=%5u"
  0,    //  216: "Delta Otbor SR Rectif=%3u"
  0,    //  217: "Temp Okon Otbor SR Rectif=%3i"
  0,    //  218: "Temp Okon Rectif=%3i"
  1,    //  219: "Power GLV simple Distill=%4i"
  1,    //  220: "Power simple Distill=%4i"
  1,    //  221: "Temp Begin Dist (+Def -Kub)=%3i"
  1,    //  222: "Temp Distill With Defl=%3i"
  1,    //  223: "Delta Distill With Defl=%3i"
  1,    //  224: "Temp Kub Okon DistWithDefl=%3i"
  0,    //  225: "BeepEndProc=%1u"
  0,    //  226: "BeepStateProc=%1u"
  0,    //  227: "BeepKeyPress=%1u"
  0,    //  228: "no "
  1,    //  229: "Power Termostat=%4i"
  0,    //  230: "Period Refresh Server(sec)=%3u"
  0,    //  231: "U Peregrev=%3uV"
  0,    //  232: "no "
  0,    //  233: "Provod SR=%4i"
  0,    //  234: "Time Stab (+/-) Kolonna=%5isec"
  0,    //  235: "Edit T & CHIM Count CHIM=%3i"
  0,    //  236: "Auto - CHIM=%3i"
  0,    //  237: "Auto + CHIM=%3i"
  0,    //  238: "Time Auto + CHIM=%5isec"
  0,    //  239: "Time reStab(+/-) Kolonna=%5isec"
  0,    //  240: "no "
  0,    //  241: "Power correct ASC712 =%3i"
  0,    //  242: "no "
  0,    //  243: "no "
  0,    //  244: "no "
  0,    //  245: "no "
  0,    //  246: "Alarm Pressure MPX5010=%i"
  0,    //  247: "Use Avtonom HLD=%i"
  0,    //  248: "no "
  0,    //  249: "PID Paramters %4i %4i %4i"
  0,    //  250: "min %% CHIM Otbor SR=%2i"
  0,    //  251: "Edit Temp Stab Rectif=%3i"
  0,    //  252: "Beg %% CHIM Otbor SR=%2i"
  0,    //  253: "Popr MPX=%4i %4i/%4i"
  0,    //  254: "no "
  0,    //  255: "no "
  0,    //  256: "no "
  0,    //  257: "Fraction Dist Count =%3i"
  0,    //  258: "Fraction Rectif Count =%3i"
  0,    //  259: "no "
  0,    //  260: "no "
  0,    //  261: "no "
  0,    //  262: "no "
  0,    //  263: "no "
  0,    //  264: "no "
  0,    //  265: "no "
  0,    //  266: "no "
  0,    //  267: "no "
  0     //  268: "%% otbor Tsarga Paster(+/-)=%3i"
};

#define NEED_DS18B20_PRESET 0

#if defined(NEED_DS18B20_PRESET) && (NEED_DS18B20_PRESET==1)
// Added by Phisik on 2017-08-16
// Ниже мы займемся датчиками DS18B20. Если датчики зафиксированы и никак их не поменять местами, то вам сюда.

// Количество пресетов для датчиков, по ним потом будет сортировать те, что найдем
// Вам тут надо точно указать сколько у вас наборов, иначе все сгорит... Просто не скомпилируется :)
#define DS18B20_PRESET_NUM   2

// В этой переменной хранятся адреса нужных нам датчиков
// Я оставил здесь свои номера, вы ставьте свои.

// Адреса надо предварительно получить сканнером. Брать его в примерах File->Example->OneWire->ds18x20_temperature,
// здесь https://www.pjrc.com/teensy/td_libs_OneWire.html или  искать мои сообщения на HomeDistillers.
// Меняем пин OneWire на 37 - (OneWire  ds(37);), заливаем его на наш контроллер и топаем к колонне.
// Числа должны быть в шестнадцатеричной системе исчисления, т.е. дописываем 0x (ноль-икс)
// к тому, что выплюнет сканнер. Смотрим пример:

// Это выплюнул сканер:
//      ROM = 28 FF 30 6A A2 16 3 5A
//        Chip = DS18B20
//        Data = 1 B0 1 4B 46 7F FF C 10 9B  CRC=9B
//        Temperature = 27.00 Celsius, 80.60 Fahrenheit
//      ROM = 28 FF D5 FB A1 16 4 5B
//        Chip = DS18B20
//        Data = 1 AF 1 4B 46 7F FF C 10 35  CRC=35
//        Temperature = 26.94 Celsius, 80.49 Fahrenheit
//      ROM = 28 FF A7 34 A2 16 5 AC
//        Chip = DS18B20
//        Data = 1 B1 1 4B 46 7F FF C 10 D8  CRC=D8
//        Temperature = 27.06 Celsius, 80.71 Fahrenheit
//      No more addresses.

// Видим 3 датчика, их адреса "ROM = x x x x x x x ", и температуру каждого,
// греем те, что до которых дотянемся, выясняем какой куда приварен. Далее формируем массив адресов
// датчиков, он трехмерный, стараемcя не запутаться в скобках, помним про ноль-икс!

const byte dsSensorPreset[DS18B20_PRESET_NUM][MAX_DS1820][8] = {
  { // первый набор
    {0x28, 0xFF, 0x30, 0x6A, 0xA2, 0x16, 0x3, 0x5A},  // Первый датчик из первого набора
    {0x28, 0xFF, 0xD5, 0xFB, 0xA1, 0x16, 0x4, 0x5B},  // Второй датчик из первого набора
    {0x28, 0xFF, 0xA7, 0x34, 0xA2, 0x16, 0x5, 0xAC},  // Третий датчик из первого набора
    {0, 0, 0, 0, 0, 0, 0, 0},                         // Если каких-то датчиков нет, то ставим нули
    {0, 0, 0, 0, 0, 0, 0, 0} // Запятую в конце перед фигурной скобкой не надо
  },
  { // Второй набор
    {0x28, 0xFF, 0x30, 0x6A, 0xA2, 0x16, 0x3, 0x5A},   // Первый датчик из второго набора
    {0x28, 0xFF, 0xD5, 0xFB, 0xA1, 0x16, 0x4, 0x5B},   // Дальше я думаю все понятно...
    {0x28, 0xFF, 0xA7, 0x34, 0xA2, 0x16, 0x5, 0xAC},
    {0, 0, 0, 0, 0, 0, 0, 0},
    {0, 0, 0, 0, 0, 0, 0, 0}
  } // Тут тоже без запятой
}; // dsSensorPreset[][][]


#endif
